---
title: XRWebGLLayer.getViewport()
slug: Web/API/XRWebGLLayer/getViewport
tags:
  - API
  - AR
  - Layer
  - Method
  - Reality
  - Reference
  - VR
  - Virtual
  - WebGL
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRWebGLLayer
  - augmented
  - getViewport
  - viewport
---
<p>{{securecontext_header}}{{APIRef("WebXR Device API")}}</p>

<p><span class="seoSummary">The {{domxref("XRWebGLLayer")}} interface's <code><strong>getViewport()</strong></code> method returns the {{domxref("XRViewport")}} that should be used to render the specified {{domxref("XRView")}} into the WebGL layer.</span> For WebXR devices which use a single framebuffer for both the left and right eyes, the returned viewport represents the region of the framebuffer into which the scene should be rendered for the eye represented by the view.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">let <em>viewport</em> = <em>xrWebGLLayer</em>.getViewport(<em>view</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>view</code></dt>
 <dd>An {{domxref("XRView")}} object indicating the view for which the viewport is to be returned.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("XRViewport")}} object representing the viewport which will restrict drawing to the portion of the layer corresponding to the specified <code>view</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>InvalidStateError</code></dt>
 <dd>Either the specified <code>view</code> is not in an active {{domxref("XRFrame")}} or that <code>XRFrame</code> and the {{domxref("XRWebGLLayer")}} are not part of the same <a href="/en-US/docs/Web/API/XRSession">WebXR session</a>.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>This example demonstrates in part what the callback for the {{domxref("XRSession.requestAnimationFrame", "requestAnimationFrame()")}} function might look like, using <code>getViewport()</code> to get the viewport so that drawing can be constrained to the area set aside for the eye whose viewpoint is currently being rendered.</p>

<p>This works because the set of views returned by an {{domxref("XRViewerPose")}} each represent one eye's perspective on the scene. Since the framebuffer is split in half, one half for each eye, setting the WebGL viewport to match the WebXR layer's viewport will ensure that when rendering the scene for the current eye's pose, it is rendered into the correct half of the framebuffer.</p>

<p><strong>&lt;&lt;&lt;--- add link to appropriate section in the Cameras and views article ---&gt;&gt;&gt;</strong></p>

<pre class="brush: js">function drawFrame(time, frame) {
  let session = frame.session;

  let pose = frame.getViewerPose(mainReferenceSpace);

  if (pose) {
    let glLayer = session.renderState.baseLayer;
    gl.bindFramebuffer(gl.FRAMEBUFFER, glLayer.framebuffer);

    gl.clearColor(0, 0, 0, 1.0);
    gl.clearDepth(1.0);
    gl.clear(gl.COLOR_BUFFER_BIT, gl.DEPTH_COLOR_BIT);

    for (let view of pose.views) {
      let viewport = glLayer.getViewport(view);
      gl.viewport(viewport.x, viewport.y, viewport.width, viewport.height);

      /* Render the scene now */
  }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrwebgllayer-getviewport','XRWebGLLayer.getViewport()')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRWebGLLayer.getViewport")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
 <li>{{domxref("WebGLLayerInit")}}</li>
</ul>
